﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;

namespace ThreadWatchDogCon
{
    public class ProcessInfo
    {
        private IList<ProcessorTimeInfo> processorTimeHistory = new List<ProcessorTimeInfo>();

        private IList<ThreadInfo> threads = new List<ThreadInfo>();

        public ProcessInfo()
        {
        }

        public ProcessInfo(Process p)
        {
            if (p == null)
            {
                throw new ArgumentNullException("p");
            }

            this.Id = p.Id;

            try
            {
                this.StartTime = p.StartTime;
            }
            catch (Exception)
            {
                this.StartTime = DateTime.MinValue;
            }

            try
            {
                this.MainModuleFileName = p.MainModule.FileName;
            }
            catch (Exception)
            {
                this.MainModuleFileName = null;
            }
        }

        public Process Process { get; set; }

        public int Id { get; set; }

        public DateTime StartTime { get; set; }

        public string MainModuleFileName { get; set; }

        public long Version { get; set; }

        public bool Ignore { get; set; }

        public IList<ProcessorTimeInfo> ProcessorTimeHistory
        {
            get
            {
                return this.processorTimeHistory;
            }
        }

        public IList<ThreadInfo> Threads
        {
            get
            {
                return this.threads;
            }

            internal set
            {
                this.threads = value;
            }
        }
    }
}
