﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;

namespace ThreadWatchDogCon
{
    public class ThreadInfo
    {
        private IList<ProcessorTimeInfo> processorTimeHistory = new List<ProcessorTimeInfo>();

        public ThreadInfo()
        {
        }

        public ThreadInfo(ProcessThread pt)
        {
            if (pt == null)
            {
                throw new ArgumentNullException("pt");
            }

            this.Id = pt.Id;

            try
            {
                this.StartTime = pt.StartTime;
            }
            catch (Exception)
            {
                this.StartTime = DateTime.MinValue;
            }
        }

        public ProcessThread Thread { get; set; }

        public int Id { get; set; }

        public DateTime StartTime { get; set; }

        public long Version { get; set; }

        public bool Ignore { get; set; }

        public IList<ProcessorTimeInfo> ProcessorTimeHistory
        {
            get
            {
                return this.processorTimeHistory;
            }
        }
    }
}
